//
//TOutputMenuField.cpp
//

#include "TOutputMenuField.h"
#include <Message.h>
#include <MenuItem.h>
#include <MidiDefs.h>

TOutputMenuField :: TOutputMenuField(BRect frame, const char *name, const char *label, BMenu *menu, int16 channel)
: BMenuField(frame, name,label,menu)
{ 
	CH = channel;
	BMessage* m;
	BMenuItem* item;
	
	m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",128);
    item = new BMenuItem("off",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",-127);
    item = new BMenuItem("midiout",m);
    Menu()->AddItem(item);
    
    Menu()->AddSeparatorItem();
    		
    if(CH==3){
    			m = new BMessage('inst');
    			m->AddInt16("CH",CH);
    			m->AddInt16("inst",-1);
    			item = new BMenuItem("Velosity of A",m);
    			Menu()->AddItem(item);
    			m = new BMessage('inst');
    			m->AddInt16("CH",CH);
    			m->AddInt16("inst",-2);
    			item = new BMenuItem("Velosity of B",m);
    			Menu()->AddItem(item);
    			m = new BMessage('inst');
    			m->AddInt16("CH",CH);
    			m->AddInt16("inst",-3);
    			item = new BMenuItem("Velosity of A,B",m);
    			Menu()->AddItem(item);
    			m = new BMessage('inst');
    			m->AddInt16("CH",CH);
    			m->AddInt16("inst",-7);
    			item = new BMenuItem("Clock",m);
    			Menu()->AddItem(item);
    			Menu()->AddSeparatorItem();
    }
    		m = new BMessage('inst');
    		m->AddInt16("CH",CH);
    		m->AddInt16("inst",-10);
    		item = new BMenuItem("Percussion",m);
    		Menu()->AddItem(item);
    		Menu()->AddSeparatorItem();
 
 	m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_GRAND);
    item = new BMenuItem("B_ACOUSTIC_GRAND",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BRIGHT_GRAND);
    item = new BMenuItem("B_BRIGHT_GRAND",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_GRAND);
    item = new BMenuItem("B_ELECTRIC_GRAND",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_HONKY_TONK);
    item = new BMenuItem("B_HONKY_TONK",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_PIANO_1);
    item = new BMenuItem("B_ELECTRIC_PIANO_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_PIANO_2);
    item = new BMenuItem("B_ELECTRIC_PIANO_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_HARPSICHORD);
    item = new BMenuItem("B_HARPSICHORD",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CLAVICHORD);
    item = new BMenuItem("B_CLAVICHORD",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CELESTA);
    item = new BMenuItem("B_CELESTA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_GLOCKENSPIEL);
    item = new BMenuItem("B_GLOCKENSPIEL",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_MUSIC_BOX);
    item = new BMenuItem("B_MUSIC_BOX",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VIBRAPHONE);
    item = new BMenuItem("B_VIBRAPHONE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_MARIMBA);
    item = new BMenuItem("B_MARIMBA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_XYLOPHONE);
    item = new BMenuItem("B_XYLOPHONE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TUBULAR_BELLS);
    item = new BMenuItem("B_TUBULAR_BELLS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_DULCIMER);
    item = new BMenuItem("B_DULCIMER",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_DRAWBAR_ORGAN);
    item = new BMenuItem("B_DRAWBAR_ORGAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_PERCUSSIVE_ORGAN);
    item = new BMenuItem("B_PERCUSSIVE_ORGAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ROCK_ORGAN);
    item = new BMenuItem("B_ROCK_ORGAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CHURCH_ORGAN);
    item = new BMenuItem("B_CHURCH_ORGAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_REED_ORGAN);
    item = new BMenuItem("B_REED_ORGAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACCORDION);
    item = new BMenuItem("B_ACCORDION",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_HARMONICA);
    item = new BMenuItem("B_HARMONICA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TANGO_ACCORDION);
    item = new BMenuItem("B_TANGO_ACCORDION",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_GUITAR_NYLON);
    item = new BMenuItem("B_ACOUSTIC_GUITAR_NYLON",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_GUITAR_STEEL);
    item = new BMenuItem("B_ACOUSTIC_GUITAR_STEEL",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_GUITAR_JAZZ);
    item = new BMenuItem("B_ELECTRIC_GUITAR_JAZZ",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_GUITAR_CLEAN);
    item = new BMenuItem("B_ELECTRIC_GUITAR_CLEAN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_GUITAR_MUTED);
    item = new BMenuItem("B_ELECTRIC_GUITAR_MUTED",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_OVERDRIVEN_GUITAR);
    item = new BMenuItem("B_OVERDRIVEN_GUITAR",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_DISTORTION_GUITAR);
    item = new BMenuItem("B_DISTORTION_GUITAR",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_GUITAR_HARMONICS);
    item = new BMenuItem("B_GUITAR_HARMONICS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_BASS);
    item = new BMenuItem("B_ACOUSTIC_BASS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_BASS_FINGER);
    item = new BMenuItem("B_ELECTRIC_BASS_FINGER",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ELECTRIC_BASS_PICK);
    item = new BMenuItem("B_ELECTRIC_BASS_PICK",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FRETLESS_BASS);
    item = new BMenuItem("B_FRETLESS_BASS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SLAP_BASS_1);
    item = new BMenuItem("B_SLAP_BASS_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SLAP_BASS_2);
    item = new BMenuItem("B_SLAP_BASS_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_BASS_1);
    item = new BMenuItem("B_SYNTH_BASS_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_BASS_2);
    item = new BMenuItem("B_SYNTH_BASS_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VIOLIN);
    item = new BMenuItem("B_VIOLIN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VIOLA);
    item = new BMenuItem("B_VIOLA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CELLO);
    item = new BMenuItem("B_CELLO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CONTRABASS);
    item = new BMenuItem("B_CONTRABASS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TREMOLO_STRINGS);
    item = new BMenuItem("B_TREMOLO_STRINGS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_PIZZICATO_STRINGS);
    item = new BMenuItem("B_PIZZICATO_STRINGS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ORCHESTRAL_STRINGS);
    item = new BMenuItem("B_ORCHESTRAL_STRINGS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TIMPANI);
    item = new BMenuItem("B_TIMPANI",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_STRING_ENSEMBLE_1);
    item = new BMenuItem("B_STRING_ENSEMBLE_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_STRING_ENSEMBLE_2);
    item = new BMenuItem("B_STRING_ENSEMBLE_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_STRINGS_1);
    item = new BMenuItem("B_SYNTH_STRINGS_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_STRINGS_2);
    item = new BMenuItem("B_SYNTH_STRINGS_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VOICE_AAH);
    item = new BMenuItem("B_VOICE_AAH",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VOICE_OOH);
    item = new BMenuItem("B_VOICE_OOH",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_VOICE);
    item = new BMenuItem("B_SYNTH_VOICE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ORCHESTRA_HIT);
    item = new BMenuItem("B_ORCHESTRA_HIT",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TRUMPET);
    item = new BMenuItem("B_TRUMPET",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_GRAND);
    item = new BMenuItem("B_ACOUSTIC_GRAND",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TROMBONE);
    item = new BMenuItem("B_TROMBONE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TUBA);
    item = new BMenuItem("B_TUBA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_MUTED_TRUMPET);
    item = new BMenuItem("B_MUTED_TRUMPET",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FRENCH_HORN);
    item = new BMenuItem("B_FRENCH_HORN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BRASS_SECTION);
    item = new BMenuItem("B_BRASS_SECTION",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_BRASS_1);
    item = new BMenuItem("B_SYNTH_BRASS_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_BRASS_2);
    item = new BMenuItem("B_SYNTH_BRASS_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SOPRANO_SAX);
    item = new BMenuItem("B_SOPRANO_SAX",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ALTO_SAX);
    item = new BMenuItem("B_ALTO_SAX",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TENOR_SAX);
    item = new BMenuItem("B_TENOR_SAX",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BARITONE_SAX);
    item = new BMenuItem("B_BARITONE_SAX",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_OBOE);
    item = new BMenuItem("B_OBOE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ENGLISH_HORN);
    item = new BMenuItem("B_ENGLISH_HORN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BASSOON);
    item = new BMenuItem("B_BASSOON",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CLARINET);
    item = new BMenuItem("B_CLARINET",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_PICCOLO);
    item = new BMenuItem("B_PICCOLO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FLUTE);
    item = new BMenuItem("B_FLUTE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_RECORDER);
    item = new BMenuItem("B_RECORDER",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_PAN_FLUTE);
    item = new BMenuItem("B_PAN_FLUTE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BLOWN_BOTTLE);
    item = new BMenuItem("B_BLOWN_BOTTLE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SHAKUHACHI);
    item = new BMenuItem("B_SHAKUHACHI",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_WHISTLE);
    item = new BMenuItem("B_WHISTLE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_OCARINA);
    item = new BMenuItem("B_OCARINA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SQUARE_WAVE);
    item = new BMenuItem("B_SQUARE_WAVE",m);
    if(CH==1)item->SetMarked(true);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SAWTOOTH_WAVE);
    item = new BMenuItem("B_SAWTOOTH_WAVE",m);
    if(CH==2)item->SetMarked(true);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CALLIOPE);
    item = new BMenuItem("B_CALLIOPE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CHIFF);
    item = new BMenuItem("B_CHIFF",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CHARANG);
    item = new BMenuItem("B_CHARANG",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_VOICE);
    item = new BMenuItem("B_VOICE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FIFTHS);
    item = new BMenuItem("B_FIFTHS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BASS_LEAD);
    item = new BMenuItem("B_BASS_LEAD",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_NEW_AGE);
    item = new BMenuItem("B_NEW_AGE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_WARM);
    item = new BMenuItem("B_WARM",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_POLYSYNTH);
    item = new BMenuItem("B_POLYSYNTH",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_CHOIR);
    item = new BMenuItem("B_CHOIR",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BOWED);
    item = new BMenuItem("B_BOWED",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_METALLIC);
    item = new BMenuItem("B_METALLIC",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_HALO);
    item = new BMenuItem("B_HALO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SWEEP);
    item = new BMenuItem("B_SWEEP",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_1);
    item = new BMenuItem("B_FX_1",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_2);
    item = new BMenuItem("B_FX_2",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_3);
    item = new BMenuItem("B_FX_3",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_4);
    item = new BMenuItem("B_FX_4",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_5);
    item = new BMenuItem("B_FX_5",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_6);
    item = new BMenuItem("B_FX_6",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_7);
    item = new BMenuItem("B_FX_7",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FX_8);
    item = new BMenuItem("B_FX_8",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SITAR);
    item = new BMenuItem("B_SITAR",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BANJO);
    item = new BMenuItem("B_BANJO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SHAMISEN);
    item = new BMenuItem("B_SHAMISEN",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_KOTO);
    item = new BMenuItem("B_KOTO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_KALIMBA);
    item = new BMenuItem("B_KALIMBA",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BAGPIPE);
    item = new BMenuItem("B_BAGPIPE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FIDDLE);
    item = new BMenuItem("B_FIDDLE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SHANAI);
    item = new BMenuItem("B_SHANAI",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TINKLE_BELL);
    item = new BMenuItem("B_TINKLE_BELL",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_AGOGO);
    item = new BMenuItem("B_AGOGO",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_STEEL_DRUMS);
    item = new BMenuItem("B_STEEL_DRUMS",m);
    if(CH==3)item->SetMarked(true);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_WOODBLOCK);
    item = new BMenuItem("B_WOODBLOCK",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TAIKO_DRUMS);
    item = new BMenuItem("B_TAIKO_DRUMS",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_MELODIC_TOM);
    item = new BMenuItem("B_MELODIC_TOM",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SYNTH_DRUM);
    item = new BMenuItem("B_SYNTH_DRUM",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_REVERSE_CYMBAL);
    item = new BMenuItem("B_REVERSE_CYMBAL",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_FRET_NOISE);
    item = new BMenuItem("B_FRET_NOISE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_ACOUSTIC_GRAND);
    item = new BMenuItem("B_ACOUSTIC_GRAND",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BREATH_NOISE);
    item = new BMenuItem("B_BREATH_NOISE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_SEASHORE);
    item = new BMenuItem("B_SEASHORE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_BIRD_TWEET);
    item = new BMenuItem("B_BIRD_TWEET",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_TELEPHONE);
    item = new BMenuItem("B_TELEPHONE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_APPLAUSE);
    item = new BMenuItem("B_APPLAUSE",m);
    Menu()->AddItem(item);
    m = new BMessage('inst');
    m->AddInt16("CH",CH);
    m->AddInt16("inst",B_GUNSHOT);
    item = new BMenuItem("B_GUNSHOT",m);
    Menu()->AddItem(item);
}  


